﻿$(function () {
    $('.documentation-tree-container > ul > li:not(.empty) > a').click(function(){
        $(this).parent().toggleClass('expanded');
        checkTreeHeight();
        return false;
    });

    $('.documentation-tree-container li.selected').parents('.documentation-tree-container > ul > li').addClass('expanded').addClass('selected');

    function scrollY() {
        return window.scrollY || window.pageYOffset || 0;
    }

    var content = $('.documentation-content').last();
    var contentHeight = content.height();
    var titleHeight = $('.title-container').height();
    var tree = $('.documentation-tree-container');

    var headings = tree.find('.headings .heading').get().map(function (a) {
        var target = $(a.getAttribute('href'));
        target.append($('<a>').attr({
            href: a.getAttribute('href'),
            'class': 'heading-link'
        }));
        return [a, target.offset().top];
    });
    if (headings.length) {
        $(window).on('scroll', function () {
            var heading = null;
            headings.forEach(function (h) {
                if (h[1] < scrollY() + window.innerHeight / 4) {
                    heading = h[0];
                }
            });
            headings.forEach(function (h) {
                if (heading === h[0]) {
                    $(h[0]).parent().addClass('selected');
                } else {
                    $(h[0]).parent().removeClass('selected');
                }
            });
        });
    }

    var minTop = null, maxTop = null;
    function checkTreeHeight() {
        minTop = tree.offset().top;
        maxTop = minTop + titleHeight + contentHeight - tree.height() + 75;
        $(window).off('scroll', handleTreeScroll);
        if (maxTop - minTop > titleHeight) {
            $(window).on('scroll', handleTreeScroll);
        } else {
            minTop = maxTop = null;
        }
        handleTreeScroll();
    }
    checkTreeHeight();

    function handleTreeScroll() {
        if (minTop === null) {
            tree.css({
                position: 'static',
                top: '0'
            });
            return;
        }
        if (scrollY() < minTop) {
            tree.css({
                position: 'static',
                top: '0'
            });
        } else if (scrollY() >= maxTop) {
            tree.css({
                position: 'absolute',
                top: maxTop + 'px'
            });
        } else {
            tree.css({
                position: 'fixed',
                top: '0'
            });
        }
    }
});